import * as hljs from 'highlight.js';

hljs.configure({ classPrefix: '' });

export type Entry = string | { type: string; content: Entry[] };

export function parse(source: string) {
	let html = hljs.highlightAuto(source).value.replace(/\t/g, '    ');
	let position = 0;

	const peak = (find: string) => html.substr(position, find.length) === find;
	const parseEntry = () => {
		let parts: Entry[] = [''];

		while (position < html.length) {
			if (peak('<span class="')) {
				position += '<span class="'.length;
				let type = '';

				while (!peak('"') && position < html.length) {
					type += html[position];
					position += 1;
				}

				position += '">'.length;

				parts.push({ type: type, content: parseEntry() }, '');
			} else if (peak('</span>')) {
				position += '</span>'.length;
				return parts;
			} else {
				parts[parts.length - 1] += html[position];
				position += 1;
			}
		}

		return parts;
	};

	return parseEntry();
}
